/* interface.c - originally generated by glade */

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include "interface.h"
#include "callbacks.h"
#include "gtk_gl.h"
#include "viewnup.h"
#include "lookup_table.h"
#include "pixmaps.h"

/* menu structure for itemfactory  */
static GtkItemFactoryEntry menu_items[] = {
   {"/_File", NULL, NULL, 0, "<Branch>"},
   {"/File/tear", NULL, NULL, 0, "<Tearoff>"},
   {"/File/_Open scheme...", "<control>O", open_scheme_activate, 0, "<Item>"},
   {"/File/_Open cmap...", NULL, open_cmap_activate, 0, "<Item>"},
   {"/File/sep0", NULL, NULL, 0, "<Separator>"},
   {"/File/_Save view", NULL, save_view_activate, 0, "<Item>"},
   {"/File/_Save pane", NULL, save_pane_activate, 0, "<Item>"},
   {"/File/_Save window", NULL, save_window_activate, 0, "<Item>"},
   {"/File/sep1", NULL, NULL, 0, "<Separator>"},
   {"/File/_Print", "<CTRL>P", print_activate, 0, "<StockItem>", GTK_STOCK_PRINT},
   {"/File/_Quit", "<CTRL>Q", exit_activate, 0, "<StockItem>", GTK_STOCK_QUIT},

   {"/_Edit", NULL, NULL, 0, "<Branch>"},
   {"/Edit/tear", NULL, NULL, 0, "<Tearoff>"},

   {"/_Options", NULL, NULL, 0, "<Branch>"},
   {"/Options/tear", NULL, NULL, 0, "<Tearoff>"},
   {"/Options/_Dump pinfo", NULL, dump_info_activate, 0, "<Item>"},
   {"/Options/_Synch", "<CTRL>S", synch_activate, 0, "<Item>"},
   {"/Options/Pane _Info", "<CTRL>I", pane_info_activate, 0, "<Item>"},
   {"/Options/Intensity profiles", NULL, intensity_profiles_activate, 0, "<Item>"},

   {"/_Help", NULL, NULL, 0, "<LastBranch>"},
   {"/Help/tear", NULL, NULL, 0, "<Tearoff>"},
   {"/Help/About...", "<CTRL>?", about_activate, 0, "<Item>"},
   {"/Help/Manual...", NULL, manual_activate, 0, "<Item>"},
   };

/* Returns a menubar widget from the above array -- from the GTK2.0 tutorial */
static GtkWidget *get_menubar_menu(GtkWidget * window)
{
   GtkItemFactory *item_factory;
   GtkAccelGroup *accel_group;

   /* get the number of menu items */
   gint     nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);

   accel_group = gtk_accel_group_new();
   item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
   gtk_item_factory_create_items(item_factory, nmenu_items, menu_items, NULL);
   gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);

   return gtk_item_factory_get_widget(item_factory, "<main>");
   }

/* delete a views widgets */
void delete_view_widgets(Pane_info pane, View_info view)
{
   /* first remove the glarea from the frame */
   gtk_widget_ref(GTK_WIDGET(view->gtkgl_widget));
   gtk_container_remove(GTK_CONTAINER(view->view_frame), GTK_WIDGET(view->gtkgl_widget));
   gtk_widget_destroy(GTK_WIDGET(view->gtkgl_widget));

   /* then the frame itself */
   gtk_widget_ref(GTK_WIDGET(view->view_frame));
   gtk_container_remove(GTK_CONTAINER(pane->vbox_img), GTK_WIDGET(view->view_frame));
   gtk_widget_destroy(GTK_WIDGET(view->view_frame));
   }

/* create and show the widgets for a view */
void create_view_widgets(Main_info * ptr, Pane_info pane, View_info view)
{
   view->view_frame = gtk_frame_new(NULL);
   gtk_widget_show(view->view_frame);
   gtk_box_pack_start(GTK_BOX(pane->vbox_img), view->view_frame, TRUE, TRUE, 0);
   gtk_frame_set_shadow_type(GTK_FRAME(view->view_frame), GTK_SHADOW_ETCHED_IN);

   view->gtkgl_widget = create_gtkgl_widget(ptr, pane, view);
   gtk_widget_show(view->gtkgl_widget);
   gtk_container_add(GTK_CONTAINER(view->view_frame), view->gtkgl_widget);
   GTK_WIDGET_SET_FLAGS(view->gtkgl_widget, GTK_CAN_FOCUS);
   }

/* delete a panes widgets */
void delete_pane_widgets(Main_info * ptr, Pane_info pane)
{
   int      c;

   /* first delete the views */
   for(c = 0; c < pane->views->len; c++){
      delete_view_widgets(pane, g_ptr_array_index(pane->views, c));
      }
   }

/* create and show the widgets for a pane */
void create_pane_widgets(Main_info * ptr, Pane_info pane)
{
   GtkWidget *hbox_value_cmap;
   
   pane->pane_frame = gtk_frame_new(NULL);
   gtk_widget_show(pane->pane_frame);
   gtk_box_pack_start(GTK_BOX(ptr->pane_hbody), pane->pane_frame, TRUE, TRUE, 0);
   gtk_frame_set_shadow_type(GTK_FRAME(pane->pane_frame), GTK_SHADOW_ETCHED_IN);
   
   pane->hbox_pane = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pane->hbox_pane);
   gtk_container_add(GTK_CONTAINER(pane->pane_frame), pane->hbox_pane);
   
   pane->vbox_pane = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(pane->vbox_pane);
   gtk_box_pack_start(GTK_BOX(pane->hbox_pane), pane->vbox_pane, TRUE, TRUE, 0);

   pane->hbox_header = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pane->hbox_header);
   gtk_box_pack_start(GTK_BOX(pane->vbox_pane), pane->hbox_header, FALSE, TRUE, 0);

   /* left button and arrow */
   pane->left_button = gtk_button_new();
   gtk_widget_show(pane->left_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->left_button, FALSE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->left_button, _("Move this pane left"), NULL);

   pane->arrow_left = gtk_arrow_new(GTK_ARROW_LEFT, GTK_SHADOW_OUT);
   gtk_widget_show(pane->arrow_left);
   gtk_container_add(GTK_CONTAINER(pane->left_button), pane->arrow_left);

   /* sync button */
   pane->sync_button = gtk_button_new_with_label(_("S:-"));
   gtk_widget_show(pane->sync_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->sync_button, FALSE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->sync_button, _("Sync container to use"),
                        NULL);

   /* file entry */
   pane->file_open_combo = gtk_combo_new();
   gtk_widget_show(pane->file_open_combo);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->file_open_combo, TRUE, TRUE, 0);

   pane->file_open_button = gtk_button_new();
   gtk_widget_show(pane->file_open_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->file_open_button, FALSE, TRUE, 0);

   pane->file_open_pixmap = gtk_image_new_from_stock("gtk-open", GTK_ICON_SIZE_MENU);
   gtk_widget_show(pane->file_open_pixmap);
   gtk_container_add(GTK_CONTAINER(pane->file_open_button), pane->file_open_pixmap);

   /* close button */
   pane->close_button = gtk_button_new();
   gtk_widget_show(pane->close_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->close_button, FALSE, FALSE, 0);

   pane->close_pixmap = gtk_image_new_from_stock("gtk-delete", GTK_ICON_SIZE_MENU);
   gtk_widget_show(pane->close_pixmap);
   gtk_container_add(GTK_CONTAINER(pane->close_button), pane->close_pixmap);

   /* right button and arrow */
   pane->right_button = gtk_button_new();
   gtk_widget_show(pane->right_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_header), pane->right_button, FALSE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->right_button, _("Move this pane Right"),
                        NULL);

   pane->arrow_right = gtk_arrow_new(GTK_ARROW_RIGHT, GTK_SHADOW_OUT);
   gtk_widget_show(pane->arrow_right);
   gtk_container_add(GTK_CONTAINER(pane->right_button), pane->arrow_right);

   /* header callbacks */
   g_signal_connect(G_OBJECT(pane->left_button), "clicked",
                    G_CALLBACK(left_button_clicked), pane);
   g_signal_connect(G_OBJECT(pane->right_button), "clicked",
                    G_CALLBACK(right_button_clicked), pane);
   g_signal_connect(G_OBJECT(pane->sync_button), "clicked",
                    G_CALLBACK(sync_button_clicked), pane);

   g_signal_connect(G_OBJECT(GTK_COMBO(pane->file_open_combo)->entry), "activate",
                    G_CALLBACK(file_open_entry_activate), pane);

   /* vbox for gtkgl widgets */
   pane->vbox_img = gtk_vbox_new(TRUE, 0);
   gtk_widget_show(pane->vbox_img);
   gtk_box_pack_start(GTK_BOX(pane->vbox_pane), pane->vbox_img, TRUE, TRUE, 0);

   /* coordinates */
   pane->hbox_coord = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pane->hbox_coord);
   gtk_box_pack_start(GTK_BOX(pane->vbox_pane), pane->hbox_coord, FALSE, TRUE, 0);

   pane->coord_reset_button = gtk_button_new_with_label(_("R"));
   gtk_widget_show(pane->coord_reset_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_reset_button, FALSE, TRUE,
                      0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_reset_button,
                        _("Reset Co-ordinates to default"), NULL);

   pane->coord_type_button = gtk_button_new_with_label(_("W:"));
   gtk_widget_show(pane->coord_type_button);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_type_button, FALSE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_type_button,
                        _("Flip between World and Voxel Coordinates"), NULL);

   /* set up the spinbuttons with a NULL adjustment to begin with */
   pane->coord_vx = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_vx, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_vx, _("Voxel X-Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_vx), TRUE);

   pane->coord_vy = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_vy, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_vy, _("Voxel Y-Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_vy), TRUE);

   pane->coord_vz = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_vz, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_vz, _("Voxel Z Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_vz), TRUE);

   pane->coord_vt = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_vt, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_vt, _("Voxel Time/Vector Coordinate"),
                        NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_vt), TRUE);

   pane->coord_wx = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_wx, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_wx, _("World X-Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_wx), TRUE);

   pane->coord_wy = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_wy, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_wy, _("World Y-Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_wy), TRUE);

   pane->coord_wz = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_wz, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_wz, _("World Z Coordinate"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_wz), TRUE);

   pane->coord_wt = gtk_spin_button_new(NULL, 1, 2);
   gtk_box_pack_start(GTK_BOX(pane->hbox_coord), pane->coord_wt, TRUE, TRUE, 0);
   gtk_tooltips_set_tip(ptr->tooltips, pane->coord_wt, _("World Time/Vector Coordinate"),
                        NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->coord_wt), TRUE);

   g_signal_connect(G_OBJECT(pane->coord_reset_button), "clicked",
                    G_CALLBACK(coord_reset_button_clicked), pane);
   g_signal_connect(G_OBJECT(pane->coord_type_button), "clicked",
                    G_CALLBACK(coord_type_button_clicked), pane);
   g_signal_connect(G_OBJECT(pane->coord_vx), "changed",
                    G_CALLBACK(vx_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_vy), "changed",
                    G_CALLBACK(vy_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_vz), "changed",
                    G_CALLBACK(vz_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_vt), "changed",
                    G_CALLBACK(vt_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_wx), "changed",
                    G_CALLBACK(wx_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_wy), "changed",
                    G_CALLBACK(wy_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_wz), "changed",
                    G_CALLBACK(wz_coord_changed), pane);
   g_signal_connect(G_OBJECT(pane->coord_wt), "changed",
                    G_CALLBACK(wt_coord_changed), pane);

   if(!pane->merge){

      hbox_value_cmap = gtk_hbox_new(FALSE, 0);
      gtk_widget_show(hbox_value_cmap);
      gtk_box_pack_start(GTK_BOX(pane->vbox_pane), hbox_value_cmap, FALSE, TRUE, 0);

      /* voxel value */
      pane->vox_value_button = gtk_button_new_with_label(_("real:"));
      gtk_widget_show(pane->vox_value_button);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->vox_value_button, FALSE,
                         TRUE, 0);

      pane->vox_value = gtk_entry_new();
      gtk_widget_show(pane->vox_value);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->vox_value, TRUE, TRUE, 0);
      gtk_editable_set_editable(GTK_EDITABLE(pane->vox_value), FALSE);

      g_signal_connect(G_OBJECT(pane->vox_value_button), "clicked",
                       G_CALLBACK(vox_value_button_clicked), pane);

      /* cmap */
      pane->cmap_grey_button = gtk_button_new_with_label(_("grey"));
      gtk_widget_show(pane->cmap_grey_button);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->cmap_grey_button, FALSE, TRUE,
                         0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->cmap_grey_button,
                           _("Grey Colourmap(default)"), NULL);

      pane->cmap_hot_button = gtk_button_new_with_label(_("hot"));
      gtk_widget_show(pane->cmap_hot_button);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->cmap_hot_button, FALSE, TRUE, 0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->cmap_hot_button, _("HotMetal Colourmap"),
                           NULL);

      pane->cmap_spect_button = gtk_button_new_with_label(_("spect"));
      gtk_widget_show(pane->cmap_spect_button);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->cmap_spect_button, FALSE, TRUE,
                         0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->cmap_spect_button,
                           _("Spectral Colourmap"), NULL);

      pane->cmap_bluered_button = gtk_button_new_with_label(_("bluered"));
      gtk_widget_show(pane->cmap_bluered_button);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->cmap_bluered_button, FALSE, TRUE,
                         0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->cmap_bluered_button,
                           _("Blue-Red Colourmap"), NULL);

      pane->cmap_combo = gtk_combo_new();
      gtk_widget_show(pane->cmap_combo);
      gtk_box_pack_start(GTK_BOX(hbox_value_cmap), pane->cmap_combo, TRUE, TRUE, 0);
      gtk_combo_set_value_in_list(GTK_COMBO(pane->cmap_combo), TRUE, FALSE);
      gtk_combo_set_case_sensitive(GTK_COMBO(pane->cmap_combo), TRUE);

      pane->cmap_combo_entry = GTK_COMBO(pane->cmap_combo)->entry;
      gtk_widget_show(pane->cmap_combo_entry);
      gtk_editable_set_editable(GTK_EDITABLE(pane->cmap_combo_entry), FALSE);
      gtk_entry_set_text(GTK_ENTRY(pane->cmap_combo_entry), _("grey"));

      /* range widgets. Init range widgets with a NULL adjustment */
      pane->range_table = gtk_table_new(2, 5, TRUE);
      gtk_widget_show(pane->range_table);
      gtk_box_pack_start(GTK_BOX(pane->vbox_pane), pane->range_table, FALSE, TRUE, 0);

      pane->range_min_val = gtk_spin_button_new(NULL, 1, 0);
      gtk_widget_show(pane->range_min_val);
      gtk_table_attach(GTK_TABLE(pane->range_table), pane->range_min_val, 0, 1, 0, 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->range_min_val,
                           _("Minimum value for Colourmap"), NULL);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->range_min_val), TRUE);
      gtk_spin_button_set_digits(GTK_SPIN_BUTTON(pane->range_min_val), 2);

      pane->range_min_scale = gtk_hscale_new(NULL);
      gtk_widget_show(pane->range_min_scale);
      gtk_table_attach(GTK_TABLE(pane->range_table), pane->range_min_scale, 1, 4, 0, 1,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_scale_set_draw_value(GTK_SCALE(pane->range_min_scale), FALSE);

      pane->range_max_scale = gtk_hscale_new(NULL);
      gtk_widget_show(pane->range_max_scale);
      gtk_table_attach(GTK_TABLE(pane->range_table), pane->range_max_scale, 1, 4, 1, 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_scale_set_draw_value(GTK_SCALE(pane->range_max_scale), FALSE);

      pane->range_max_val = gtk_spin_button_new(NULL, 1, 0);
      gtk_widget_show(pane->range_max_val);
      gtk_table_attach(GTK_TABLE(pane->range_table), pane->range_max_val, 4, 5, 0, 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_tooltips_set_tip(ptr->tooltips, pane->range_max_val,
                           _("Maximum value for Colourmap"), NULL);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pane->range_max_val), TRUE);
      gtk_spin_button_set_digits(GTK_SPIN_BUTTON(pane->range_max_val), 2);

      g_signal_connect(G_OBJECT(pane->range_min_val), "changed",
                       G_CALLBACK(range_min_val_changed), pane);
      g_signal_connect(G_OBJECT(pane->range_max_val), "changed",
                       G_CALLBACK(range_max_val_changed), pane);
      g_signal_connect(G_OBJECT(pane->cmap_grey_button), "clicked",
                       G_CALLBACK(cmap_grey_button_clicked), pane);
      g_signal_connect(G_OBJECT(pane->cmap_hot_button), "clicked",
                       G_CALLBACK(cmap_hot_button_clicked), pane);
      g_signal_connect(G_OBJECT(pane->cmap_spect_button), "clicked",
                       G_CALLBACK(cmap_spect_button_clicked), pane);
      g_signal_connect(G_OBJECT(pane->cmap_bluered_button), "clicked",
                       G_CALLBACK(cmap_bluered_button_clicked), pane);
      g_signal_connect(G_OBJECT(pane->cmap_combo_entry), "changed",
                       G_CALLBACK(cmap_combo_entry_changed), pane);
      }

   /* active separator - drag-able */
   pane->vsep_eventbox = gtk_event_box_new();
   gtk_widget_show(pane->vsep_eventbox);
   gtk_box_pack_start(GTK_BOX(pane->hbox_pane), pane->vsep_eventbox, FALSE, FALSE, 0);

   pane->vsep = gtk_vseparator_new();
   gtk_widget_show(pane->vsep);
   gtk_container_add(GTK_CONTAINER(pane->vsep_eventbox), pane->vsep);

   /* main focus in event */
   g_signal_connect(G_OBJECT(pane->hbox_pane), "set_focus_child",
                    G_CALLBACK(hbox_pane_set_focus_child), pane);

   /* pane resizing callbacks */
   g_signal_connect(G_OBJECT(pane->vsep_eventbox), "realize",
                    G_CALLBACK(vsep_eventbox_realize), pane);
   g_signal_connect(G_OBJECT(pane->vsep_eventbox), "button_press_event",
                    G_CALLBACK(vsep_eventbox_button_press_event), pane);
   g_signal_connect(G_OBJECT(pane->vsep_eventbox), "button_release_event",
                    G_CALLBACK(vsep_eventbox_button_release_event), pane);
   g_signal_connect(G_OBJECT(pane->vsep_eventbox), "motion_notify_event",
                    G_CALLBACK(vsep_eventbox_motion_notify_event), pane);
   }

GtkWidget *create_viewnup_main(Main_info * ptr)
{
   GtkWidget *viewnup_main;

   GtkWidget *menu_toolbar_hbox;
   GtkWidget *menu_handlebox;
   GtkWidget *menubar;
   GtkWidget *toolbar_handlebox;
   GtkWidget *toolbar;
   GtkWidget *statusbar_handlebox;
   GtkWidget *statusbar_hbox;

   GtkWidget *scrolledwindow;

   viewnup_main = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(viewnup_main), _("viewnup"));
   gtk_window_set_position(GTK_WINDOW(viewnup_main), GTK_WIN_POS_CENTER);
   gtk_window_set_default_size(GTK_WINDOW(viewnup_main), 1280, 1024);

   ptr->main_vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(ptr->main_vbox);
   gtk_container_add(GTK_CONTAINER(viewnup_main), ptr->main_vbox);
   
   /* top hbox for menu/toolbar/statusbar */
   menu_toolbar_hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(menu_toolbar_hbox);
   gtk_box_pack_start(GTK_BOX(ptr->main_vbox), menu_toolbar_hbox, FALSE, FALSE, 0);

   /* menubar stuff */
   menu_handlebox = gtk_handle_box_new();
   gtk_widget_show(menu_handlebox);
   gtk_box_pack_start(GTK_BOX(menu_toolbar_hbox), menu_handlebox, FALSE, FALSE, 0);
   gtk_handle_box_set_snap_edge(GTK_HANDLE_BOX(menu_handlebox), GTK_POS_LEFT);

   menubar = get_menubar_menu(viewnup_main);
   gtk_widget_show(menubar);
   gtk_container_add(GTK_CONTAINER(menu_handlebox), menubar);

   /* toolbar */
   toolbar_handlebox = gtk_handle_box_new();
   gtk_widget_show(toolbar_handlebox);
   gtk_box_pack_start(GTK_BOX(menu_toolbar_hbox), toolbar_handlebox, FALSE, TRUE, 0);

   toolbar = gtk_toolbar_new();
   gtk_toolbar_set_orientation(GTK_TOOLBAR(toolbar), GTK_ORIENTATION_HORIZONTAL);
   gtk_widget_show(toolbar);
   gtk_container_add(GTK_CONTAINER(toolbar_handlebox), toolbar);
   gtk_container_set_border_width(GTK_CONTAINER(toolbar), 3);

   /* status bar and progress bar */
   statusbar_handlebox = gtk_handle_box_new();
   gtk_widget_show(statusbar_handlebox);
   gtk_box_pack_start(GTK_BOX(menu_toolbar_hbox), statusbar_handlebox, TRUE, TRUE, 0);

   statusbar_hbox = gtk_hbox_new(FALSE, 3);
   gtk_widget_show(statusbar_hbox);
   gtk_container_add(GTK_CONTAINER(statusbar_handlebox), statusbar_hbox);
   gtk_container_set_border_width(GTK_CONTAINER(statusbar_hbox), 3);

   /* statusbar */
   ptr->statusbar = gtk_statusbar_new();
   gtk_widget_show(ptr->statusbar);
   gtk_box_pack_start(GTK_BOX(statusbar_hbox), ptr->statusbar, TRUE, TRUE, 0);

   /* progressbar */
   ptr->progressbar = gtk_progress_bar_new();
   gtk_widget_show(ptr->progressbar);
   gtk_box_pack_start(GTK_BOX(statusbar_hbox), ptr->progressbar, FALSE, TRUE, 0);

   /* main viewing window */
   scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
   gtk_widget_show(scrolledwindow);
   gtk_box_pack_start(GTK_BOX(ptr->main_vbox), scrolledwindow, TRUE, TRUE, 0);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow),
                                  GTK_POLICY_AUTOMATIC, GTK_POLICY_NEVER);

   ptr->pane_hbody = gtk_hbox_new(FALSE, 1);
   gtk_widget_show(ptr->pane_hbody);
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolledwindow),
                                         ptr->pane_hbody);

   g_object_set_data(G_OBJECT(viewnup_main), "tooltips", ptr->tooltips);

   return viewnup_main;
   }

/* DIALOGS */
/* ------- */
/* Synchs Dialog */
GtkWidget *create_synch_table(Main_info * ptr)
{
   Synch_info *sync;

   char     id_text[256];
   int      c;

   GtkWidget *table;

   GtkWidget *synch_t_label;
   GtkWidget *synch_z_label;
   GtkWidget *synch_y_label;
   GtkWidget *synch_x_label;

   GtkWidget *synch_add_button;
   GtkWidget *synch_add_separator;
   GtkWidget *synch_remove_button;
   GtkWidget *synch_remove_image;

   GtkWidget *synch_scale_image;
   GtkWidget *synch_rotation_image;
   GtkWidget *synch_translation_image;
   GtkWidget *synch_tilt_image;

   table = gtk_table_new(ptr->n_synchs + 2, 10, FALSE);
   gtk_widget_show(table);
   gtk_container_set_border_width(GTK_CONTAINER(table), 5);

   /* add labels */
   synch_x_label = gtk_label_new(_("x"));
   gtk_widget_show(synch_x_label);
   gtk_table_attach(GTK_TABLE(table), synch_x_label, 1, 2, 0, 1,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

   synch_y_label = gtk_label_new(_("y"));
   gtk_widget_show(synch_y_label);
   gtk_table_attach(GTK_TABLE(table), synch_y_label, 2, 3, 0, 1,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

   synch_z_label = gtk_label_new(_("z"));
   gtk_widget_show(synch_z_label);
   gtk_table_attach(GTK_TABLE(table), synch_z_label, 3, 4, 0, 1,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

   synch_t_label = gtk_label_new(_("t"));
   gtk_widget_show(synch_t_label);
   gtk_table_attach(GTK_TABLE(table), synch_t_label, 4, 5, 0, 1,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

   /* now create the spins - synch 0 is special case of no synch */
   for(c = 1; c < ptr->n_synchs; c++){
      sync = ptr->synchs[c];

      sprintf(id_text, "%d", sync->idx);

      sync->synch_row_label = gtk_label_new(_(id_text));
      gtk_widget_show(sync->synch_row_label);
      gtk_table_attach(GTK_TABLE(table), sync->synch_row_label, 0, 1, c + 1, c + 2,
                       (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      sync->synch_x = gtk_spin_button_new(GTK_ADJUSTMENT(sync->synch_x_adj), 1, 2);
      gtk_widget_show(sync->synch_x);
      gtk_table_attach(GTK_TABLE(table), sync->synch_x, 1, 2, c + 1, c + 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(sync->synch_x), TRUE);

      sync->synch_y = gtk_spin_button_new(GTK_ADJUSTMENT(sync->synch_y_adj), 1, 2);
      gtk_widget_show(sync->synch_y);
      gtk_table_attach(GTK_TABLE(table), sync->synch_y, 2, 3, c + 1, c + 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(sync->synch_y), TRUE);

      sync->synch_z = gtk_spin_button_new(GTK_ADJUSTMENT(sync->synch_z_adj), 1, 2);
      gtk_widget_show(sync->synch_z);
      gtk_table_attach(GTK_TABLE(table), sync->synch_z, 3, 4, c + 1, c + 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(sync->synch_z), TRUE);

      sync->synch_t = gtk_spin_button_new(GTK_ADJUSTMENT(sync->synch_t_adj), 1, 2);
      gtk_widget_show(sync->synch_t);
      gtk_table_attach(GTK_TABLE(table), sync->synch_t, 4, 5, c + 1, c + 2,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                       (GtkAttachOptions) (0), 0, 0);
      gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(sync->synch_t), TRUE);

      /* togglebuttons */
      sync->synch_scale_button = gtk_toggle_button_new();
      gtk_widget_show(sync->synch_scale_button);
      gtk_table_attach(GTK_TABLE(table), sync->synch_scale_button, 5, 6, c + 1, c + 2,
                       (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      synch_scale_image = create_pixmap(ptr->synch_dialog, SCALE_PIXMAP);
      gtk_widget_show(synch_scale_image);
      gtk_container_add(GTK_CONTAINER(sync->synch_scale_button), synch_scale_image);

      sync->synch_rotation_button = gtk_toggle_button_new();
      gtk_widget_show(sync->synch_rotation_button);
      gtk_table_attach(GTK_TABLE(table), sync->synch_rotation_button, 6, 7, c + 1, c + 2,
                       (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      synch_rotation_image = create_pixmap(ptr->synch_dialog, ROTATION_PIXMAP);
      gtk_widget_show(synch_rotation_image);
      gtk_container_add(GTK_CONTAINER(sync->synch_rotation_button), synch_rotation_image);

      sync->synch_translation_button = gtk_toggle_button_new();
      gtk_widget_show(sync->synch_translation_button);
      gtk_table_attach(GTK_TABLE(table), sync->synch_translation_button, 7, 8, c + 1,
                       c + 2, (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      synch_translation_image = create_pixmap(ptr->synch_dialog, TRANSLATION_PIXMAP);
      gtk_widget_show(synch_translation_image);
      gtk_container_add(GTK_CONTAINER(sync->synch_translation_button),
                        synch_translation_image);

      sync->synch_tilt_button = gtk_toggle_button_new();
      gtk_widget_show(sync->synch_tilt_button);
      gtk_table_attach(GTK_TABLE(table), sync->synch_tilt_button, 8, 9, c + 1, c + 2,
                       (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      synch_tilt_image = create_pixmap(ptr->synch_dialog, TILT_PIXMAP);
      gtk_widget_show(synch_tilt_image);
      gtk_container_add(GTK_CONTAINER(sync->synch_tilt_button), synch_tilt_image);

      synch_remove_button = gtk_button_new();
      gtk_widget_show(synch_remove_button);
      gtk_table_attach(GTK_TABLE(table), synch_remove_button, 9, 10, c + 1, c + 2,
                       (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);

      synch_remove_image = gtk_image_new_from_stock("gtk-delete", GTK_ICON_SIZE_MENU);
      gtk_widget_show(synch_remove_image);
      gtk_container_add(GTK_CONTAINER(synch_remove_button), synch_remove_image);

      g_signal_connect(G_OBJECT(sync->synch_x), "changed",
                       G_CALLBACK(synch_coord_changed), sync);
      g_signal_connect(G_OBJECT(sync->synch_y), "changed",
                       G_CALLBACK(synch_coord_changed), sync);
      g_signal_connect(G_OBJECT(sync->synch_z), "changed",
                       G_CALLBACK(synch_coord_changed), sync);

      g_signal_connect(G_OBJECT(synch_remove_button), "clicked",
                       G_CALLBACK(synch_remove_button_clicked), sync);
      }

   /* now add the "add" button and it's signal */
   synch_add_button = gtk_button_new_from_stock("gtk-add");
   gtk_widget_show(synch_add_button);
   gtk_table_attach(GTK_TABLE(table), synch_add_button, 0, 1, ptr->n_synchs + 1,
                    ptr->n_synchs + 2, (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0,
                    0);

   synch_add_separator = gtk_hseparator_new();
   gtk_widget_show(synch_add_separator);
   gtk_table_attach(GTK_TABLE(table), synch_add_separator, 1, 9, ptr->n_synchs + 1,
                    ptr->n_synchs + 2, (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

   g_signal_connect(G_OBJECT(synch_add_button), "clicked",
                    G_CALLBACK(synch_add_button_clicked), NULL);

   return table;
   }

GtkWidget *create_synch_dialog(Main_info * ptr)
{
   GtkWidget *synch_dialog;

   synch_dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(synch_dialog), _("Synchs"));

   /* set the Main_info ptr so we can make pixmaps */
   ptr->synch_dialog = synch_dialog;
   ptr->synch_table = create_synch_table(ptr);
   gtk_widget_ref(ptr->synch_table);
   gtk_container_add(GTK_CONTAINER(synch_dialog), ptr->synch_table);

   g_signal_connect(G_OBJECT(synch_dialog), "delete_event",
                    G_CALLBACK(synch_dialog_delete_event), NULL);

   return synch_dialog;
   }

GtkWidget *create_cmap_fileselection(void)
{
   GtkWidget *cmap_fileselection;
   GtkWidget *cmap_file_ok_button;
   GtkWidget *cmap_file_cancel_button;

   cmap_fileselection = gtk_file_selection_new(_("Select lookup table"));
   gtk_window_set_position(GTK_WINDOW(cmap_fileselection), GTK_WIN_POS_MOUSE);
   gtk_window_set_modal(GTK_WINDOW(cmap_fileselection), TRUE);

   cmap_file_ok_button = GTK_FILE_SELECTION(cmap_fileselection)->ok_button;
   gtk_widget_show(cmap_file_ok_button);
   GTK_WIDGET_SET_FLAGS(cmap_file_ok_button, GTK_CAN_DEFAULT);

   cmap_file_cancel_button = GTK_FILE_SELECTION(cmap_fileselection)->cancel_button;
   gtk_widget_show(cmap_file_cancel_button);
   GTK_WIDGET_SET_FLAGS(cmap_file_cancel_button, GTK_CAN_DEFAULT);

   g_signal_connect(G_OBJECT(cmap_file_ok_button), "clicked",
                    G_CALLBACK(cmap_file_ok_button_clicked),
                    GTK_OBJECT(cmap_fileselection));
   g_signal_connect_swapped(G_OBJECT(cmap_file_cancel_button), "clicked",
                            G_CALLBACK(gtk_widget_destroy),
                            GTK_OBJECT(cmap_fileselection));

   return cmap_fileselection;
   }

GtkWidget *create_scheme_fileselection(void)
{
   GtkWidget *scheme_fileselection;
   GtkWidget *scheme_ok_button;
   GtkWidget *scheme_cancel_button;

   scheme_fileselection = gtk_file_selection_new(_("select viewnup scheme"));
   gtk_window_set_modal(GTK_WINDOW(scheme_fileselection), TRUE);

   scheme_ok_button = GTK_FILE_SELECTION(scheme_fileselection)->ok_button;
   gtk_widget_show(scheme_ok_button);
   GTK_WIDGET_SET_FLAGS(scheme_ok_button, GTK_CAN_DEFAULT);

   scheme_cancel_button = GTK_FILE_SELECTION(scheme_fileselection)->cancel_button;
   gtk_widget_show(scheme_cancel_button);
   GTK_WIDGET_SET_FLAGS(scheme_cancel_button, GTK_CAN_DEFAULT);

   g_signal_connect(G_OBJECT(scheme_ok_button), "clicked",
                    G_CALLBACK(scheme_ok_button_clicked),
                    GTK_OBJECT(scheme_fileselection));
   g_signal_connect_swapped(G_OBJECT(scheme_cancel_button), "clicked",
                            (GtkSignalFunc) gtk_widget_destroy,
                            GTK_OBJECT(scheme_fileselection));

   return scheme_fileselection;
   }

/* about dialog */
GtkWidget *create_viewnup_about(void)
{
   return (gtk_message_dialog_new(NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_INFO,
                                  GTK_BUTTONS_NONE,
                                  _("%s\n%s\n%s\n"),
                                  _("Author: Andrew Janke - rotor@cmr.uq.edu.au"),
                                  _("Web: http://www.cmr.uq.edu.au/~rotor/software"),
                                  _("Copyright 2001-Eternity Andrew Janke")));
   }

/* pane info dialog */
GtkWidget *create_pane_info_dialog(Main_info * ptr)
{

   Pane_dialog *pi = ptr->pane_dialog;
   gint     c;
   gulong   signal_id;

   /* widgets */
   GtkWidget *pane_info_dialog;
   GtkWidget *pi_vbox;
   GtkWidget *pi_label_hbox;
   GtkWidget *pi_pane_add_button;
   GtkWidget *pi_pane_add_pixmap;
   GtkWidget *pi_pane_clone_button;
   GtkWidget *pi_pane_clone_pixmap;
   GtkWidget *pi_pane_close_button;
   GtkWidget *pi_pane_close_pixmap;

   /* view */
   GtkWidget *pi_view_frame;
   GtkWidget *pi_view_vbox;
   GtkWidget *pi_view_check_table;
   GtkWidget *pi_view_hseparator;
   GtkWidget *pi_view_hbox;

   GtkWidget *pi_view_add_button;
   GtkWidget *pi_view_add_pixmap;
   GtkWidget *pi_view_add_transverse_button;
   GtkWidget *pi_view_add_transverse_pixmap;
   GtkWidget *pi_view_add_sagittal_button;
   GtkWidget *pi_view_add_sagittal_pixmap;
   GtkWidget *pi_view_add_coronal_button;
   GtkWidget *pi_view_add_coronal_pixmap;
   GtkWidget *pi_view_clone_button;
   GtkWidget *pi_view_clone_pixmap;
   GtkWidget *pi_view_close_button;
   GtkWidget *pi_view_close_pixmap;

   GtkWidget *pi_view_det_table;
   GtkWidget *pi_scale_button;
   GtkWidget *pi_trans_button;
   GtkWidget *pi_rot_button;
   GtkWidget *pi_tilt_button;
   GtkWidget *pi_rot_phi_label;

   GtkWidget *pi_scale_link_pixmap;
   GtkWidget *pi_trans_link_pixmap;
   GtkWidget *pi_rot_link_pixmap;
   GtkWidget *pi_tilt_link_pixmap;

   GtkWidget *pi_scale_pixmap;
   GtkWidget *pi_trans_pixmap;
   GtkWidget *pi_rot_pixmap;
   GtkWidget *pi_tilt_pixmap;

   GtkWidget *pi_scale_lock_pixmap;
   GtkWidget *pi_trans_lock_x_pixmap;
   GtkWidget *pi_trans_lock_y_pixmap;
   GtkWidget *pi_trans_lock_z_pixmap;
   GtkWidget *pi_rot_lock_x_pixmap;
   GtkWidget *pi_rot_lock_y_pixmap;
   GtkWidget *pi_rot_lock_z_pixmap;
   GtkWidget *pi_rot_lock_phi_pixmap;
   GtkWidget *pi_tilt_lock_x_pixmap;
   GtkWidget *pi_tilt_lock_y_pixmap;
   GtkWidget *pi_tilt_lock_z_pixmap;

   /* cmap */
   GtkWidget *pi_cmap_vbox;
   GtkWidget *pi_cmap_table;
   GtkWidget *pi_cmap_type_hbox;

   /* vector */
   GtkWidget *pi_vector_vbox;
   GtkWidget *pi_vector_options_table;
   GtkWidget *pi_vector_mult_button;
   GtkObject *pi_vector_mult_spinbutton_adj;
   GtkObject *pi_vector_alpha_mult_spinbutton_adj;
   GtkWidget *pi_vector_colour_button;
   GtkWidget *pi_point_color_button;
   GtkWidget *pi_alpha_mult_button;
   GtkWidget *pi_vector_range_table;

   /* merge */
   GtkWidget *pi_merge_table;

   /* lists and junk */
   GList   *pi_view_type_combo_items = NULL;
   GList   *pi_cmap_combo_items = NULL;

   GtkTooltips *tooltips;

   tooltips = gtk_tooltips_new();

   pane_info_dialog = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title(GTK_WINDOW(pane_info_dialog), _("pane info"));

   pi_vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(pi_vbox);
   gtk_container_add(GTK_CONTAINER(pane_info_dialog), pi_vbox);

   /* top pane info hbox */
   pi_label_hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pi_label_hbox);
   gtk_box_pack_start(GTK_BOX(pi_vbox), pi_label_hbox, FALSE, FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(pi_label_hbox), 3);

   /* pane add, clone and close buttons */
   pi_pane_add_button = gtk_button_new();
   gtk_widget_show(pi_pane_add_button);
   gtk_box_pack_end(GTK_BOX(pi_label_hbox), pi_pane_add_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_pane_add_button, _("add a pane"), NULL);

   pi_pane_add_pixmap = create_pixmap(pane_info_dialog, ADD_PANE_PIXMAP);
   gtk_widget_show(pi_pane_add_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_pane_add_button), pi_pane_add_pixmap);

   pi_pane_clone_button = gtk_button_new();
   gtk_widget_show(pi_pane_clone_button);
   gtk_box_pack_end(GTK_BOX(pi_label_hbox), pi_pane_clone_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_pane_clone_button, _("clone the current pane"),
                        NULL);

   pi_pane_clone_pixmap = create_pixmap(pane_info_dialog, CLONE_PANE_PIXMAP);
   gtk_widget_show(pi_pane_clone_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_pane_clone_button), pi_pane_clone_pixmap);

   pi_pane_close_button = gtk_button_new();
   gtk_widget_show(pi_pane_close_button);
   gtk_box_pack_end(GTK_BOX(pi_label_hbox), pi_pane_close_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_pane_close_button, _("close the current pane"),
                        NULL);

   pi_pane_close_pixmap = create_pixmap(pane_info_dialog, CLOSE_PANE_PIXMAP);
   gtk_widget_show(pi_pane_close_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_pane_close_button), pi_pane_close_pixmap);

   /* views sub-frame */
   pi_view_frame = gtk_frame_new(_("Views(xyz)"));
   gtk_widget_show(pi_view_frame);
   gtk_box_pack_start(GTK_BOX(pi_vbox), pi_view_frame, FALSE, FALSE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(pi_view_frame), 3);

   pi_view_vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(pi_view_vbox);
   gtk_container_add(GTK_CONTAINER(pi_view_frame), pi_view_vbox);
   gtk_container_set_border_width(GTK_CONTAINER(pi_view_vbox), 3);

   pi_view_check_table = gtk_table_new(2, 4, FALSE);
   gtk_widget_show(pi_view_check_table);
   gtk_box_pack_start(GTK_BOX(pi_view_vbox), pi_view_check_table, FALSE, FALSE, 0);
   gtk_table_set_col_spacings(GTK_TABLE(pi_view_check_table), 3);

   pi->crosshair_checkbutton = gtk_check_button_new_with_label(_("crosshair"));
   gtk_widget_show(pi->crosshair_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->crosshair_checkbutton, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->crosshair_checkbutton, _("show the 3D crosshair"),
                        NULL);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pi->crosshair_checkbutton), TRUE);

   pi->perspective_checkbutton = gtk_check_button_new_with_label(_("perspective"));
   gtk_widget_show(pi->perspective_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->perspective_checkbutton, 2, 4, 0,
                    1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->perspective_checkbutton,
                        _("use perspective projection"), NULL);

   pi->vector_checkbutton = gtk_check_button_new_with_label(_("vector"));
   gtk_widget_show(pi->vector_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->vector_checkbutton, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_checkbutton,
                        _("display vector data as vectors"), NULL);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pi->vector_checkbutton), TRUE);

   pi->sbox_checkbutton = gtk_check_button_new_with_label(_("slice box"));
   gtk_widget_show(pi->sbox_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->sbox_checkbutton, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);

   pi->linear_interp_checkbutton = gtk_check_button_new_with_label(_("linear interp"));
   gtk_widget_show(pi->linear_interp_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->linear_interp_checkbutton, 0, 1,
                    0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->linear_interp_checkbutton,
                        _("use linear interpolation"), NULL);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pi->linear_interp_checkbutton), TRUE);

   pi->bbox_checkbutton = gtk_check_button_new_with_label(_("bounding box"));
   gtk_widget_show(pi->bbox_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->bbox_checkbutton, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pi->bbox_checkbutton), TRUE);

   pi->crosshair_spinbutton_adj = gtk_adjustment_new(100, 0, 100, 1, 10, 0);
   pi->crosshair_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->crosshair_spinbutton_adj), 1, 0);
   gtk_widget_show(pi->crosshair_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_check_table), pi->crosshair_spinbutton, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->crosshair_spinbutton, _("crosshair size(in mm)"),
                        NULL);

   pi_view_hseparator = gtk_hseparator_new();
   gtk_widget_show(pi_view_hseparator);
   gtk_box_pack_start(GTK_BOX(pi_view_vbox), pi_view_hseparator, TRUE, TRUE, 0);

   pi_view_hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pi_view_hbox);
   gtk_box_pack_start(GTK_BOX(pi_view_vbox), pi_view_hbox, FALSE, FALSE, 0);

   /* view type combo */
   pi->view_type_combo = gtk_combo_new();
   gtk_widget_show(pi->view_type_combo);
   gtk_box_pack_start(GTK_BOX(pi_view_hbox), pi->view_type_combo, FALSE, TRUE, 0);
   pi_view_type_combo_items = g_list_append(pi_view_type_combo_items, _("transverse"));
   pi_view_type_combo_items = g_list_append(pi_view_type_combo_items, _("sagittal"));
   pi_view_type_combo_items = g_list_append(pi_view_type_combo_items, _("coronal"));
   gtk_combo_set_popdown_strings(GTK_COMBO(pi->view_type_combo),
                                 pi_view_type_combo_items);
   g_list_free(pi_view_type_combo_items);

   pi->view_type_combo_entry = GTK_COMBO(pi->view_type_combo)->entry;
   gtk_widget_show(pi->view_type_combo_entry);
   gtk_tooltips_set_tip(tooltips, pi->view_type_combo_entry, _("the type of view"), NULL);
   gtk_editable_set_editable(GTK_EDITABLE(pi->view_type_combo_entry), FALSE);
   gtk_entry_set_text(GTK_ENTRY(pi->view_type_combo_entry), _("transverse"));

   /* view add and delete buttons */
   pi_view_add_transverse_button = gtk_button_new();
   gtk_widget_show(pi_view_add_transverse_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_add_transverse_button, FALSE, FALSE,
                    0);
   gtk_tooltips_set_tip(tooltips, pi_view_add_transverse_button, _("add another view"),
                        NULL);

   pi_view_add_transverse_pixmap =
      create_pixmap(pane_info_dialog, ADD_TRANSVERSE_VIEW_PIXMAP);
   gtk_widget_show(pi_view_add_transverse_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_add_transverse_button),
                     pi_view_add_transverse_pixmap);

   pi_view_add_sagittal_button = gtk_button_new();
   gtk_widget_show(pi_view_add_sagittal_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_add_sagittal_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_view_add_sagittal_button, _("add another view"),
                        NULL);

   pi_view_add_sagittal_pixmap =
      create_pixmap(pane_info_dialog, ADD_SAGITTAL_VIEW_PIXMAP);
   gtk_widget_show(pi_view_add_sagittal_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_add_sagittal_button),
                     pi_view_add_sagittal_pixmap);

   pi_view_add_coronal_button = gtk_button_new();
   gtk_widget_show(pi_view_add_coronal_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_add_coronal_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_view_add_coronal_button, _("add another view"),
                        NULL);

   pi_view_add_coronal_pixmap = create_pixmap(pane_info_dialog, ADD_CORONAL_VIEW_PIXMAP);
   gtk_widget_show(pi_view_add_coronal_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_add_coronal_button),
                     pi_view_add_coronal_pixmap);

   pi_view_add_button = gtk_button_new();
   gtk_widget_show(pi_view_add_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_add_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_view_add_button, _("add another view"), NULL);

   pi_view_add_pixmap = create_pixmap(pane_info_dialog, ADD_VIEW_PIXMAP);
   gtk_widget_show(pi_view_add_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_add_button), pi_view_add_pixmap);

   pi_view_clone_button = gtk_button_new();
   gtk_widget_show(pi_view_clone_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_clone_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_view_clone_button, _("clone the current view"),
                        NULL);

   pi_view_clone_pixmap = create_pixmap(pane_info_dialog, CLONE_VIEW_PIXMAP);
   gtk_widget_show(pi_view_clone_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_clone_button), pi_view_clone_pixmap);

   pi_view_close_button = gtk_button_new();
   gtk_widget_show(pi_view_close_button);
   gtk_box_pack_end(GTK_BOX(pi_view_hbox), pi_view_close_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi_view_close_button, _("close the current view"),
                        NULL);

   pi_view_close_pixmap = create_pixmap(pane_info_dialog, CLOSE_VIEW_PIXMAP);
   gtk_widget_show(pi_view_close_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_view_close_button), pi_view_close_pixmap);

   pi_view_det_table = gtk_table_new(4, 8, FALSE);
   gtk_widget_show(pi_view_det_table);
   gtk_box_pack_start(GTK_BOX(pi_view_vbox), pi_view_det_table, FALSE, FALSE, 0);
   gtk_table_set_col_spacings(GTK_TABLE(pi_view_det_table), 3);

   /* link buttons */
   pi->scale_link_button = gtk_toggle_button_new();
   gtk_widget_show(pi->scale_link_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->scale_link_button, 0, 1, 0, 1,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->scale_link_button, _("link scales between views"),
                        NULL);

   pi_scale_link_pixmap = create_pixmap(pane_info_dialog, CHAIN_V_PIXMAP);
   gtk_widget_show(pi_scale_link_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->scale_link_button), pi_scale_link_pixmap);

   pi->rot_link_button = gtk_toggle_button_new();
   gtk_widget_show(pi->rot_link_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_link_button, 0, 1, 1, 2,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_link_button, _("link rotations between views"),
                        NULL);

   pi_rot_link_pixmap = create_pixmap(pane_info_dialog, CHAIN_V_PIXMAP);
   gtk_widget_show(pi_rot_link_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->rot_link_button), pi_rot_link_pixmap);

   pi->trans_link_button = gtk_toggle_button_new();
   gtk_widget_show(pi->trans_link_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_link_button, 0, 1, 2, 3,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_link_button,
                        _("link translations between views"), NULL);

   pi_trans_link_pixmap = create_pixmap(pane_info_dialog, CHAIN_V_PIXMAP);
   gtk_widget_show(pi_trans_link_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->trans_link_button), pi_trans_link_pixmap);

   pi->tilt_link_button = gtk_toggle_button_new();
   gtk_widget_show(pi->tilt_link_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_link_button, 0, 1, 3, 4,
                    (GtkAttachOptions) (0), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_link_button, _("link tilts between views"),
                        NULL);

   pi_tilt_link_pixmap = create_pixmap(pane_info_dialog, CHAIN_V_PIXMAP);
   gtk_widget_show(pi_tilt_link_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->tilt_link_button), pi_tilt_link_pixmap);

   /* scale */
   pi_scale_button = gtk_button_new();
   gtk_widget_show(pi_scale_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi_scale_button, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_scale_button, _("click to reset scale"), NULL);

   pi_scale_pixmap = create_pixmap(pane_info_dialog, SCALE_PIXMAP);
   gtk_widget_show(pi_scale_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_scale_button), pi_scale_pixmap);

   pi->scale_lock_button = gtk_toggle_button_new();
   gtk_widget_show(pi->scale_lock_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->scale_lock_button, 2, 3, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->scale_lock_button, _("lock the scale"), NULL);

   pi_scale_lock_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_scale_lock_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->scale_lock_button), pi_scale_lock_pixmap);

   pi->scale_spinbutton_adj = gtk_adjustment_new(1, 0.1, 500, 0.01, 0.1, 0);
   pi->scale_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->scale_spinbutton_adj), 0.01, 3);
   gtk_widget_show(pi->scale_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->scale_spinbutton, 3, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->scale_spinbutton, _("scale factor to use"), NULL);

   /* rotation */
   pi_rot_button = gtk_button_new();
   gtk_widget_show(pi_rot_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi_rot_button, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_rot_button, _("click to reset rotations"), NULL);

   pi_rot_pixmap = create_pixmap(pane_info_dialog, ROTATION_PIXMAP);
   gtk_widget_show(pi_rot_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_rot_button), pi_rot_pixmap);

   pi->rot_x_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->rot_x_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->rot_x_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->rot_x_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_x_spinbutton, 3, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_x_spinbutton, _("x rotation"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->rot_x_spinbutton), TRUE);

   pi->rot_y_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->rot_y_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->rot_y_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->rot_y_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_y_spinbutton, 5, 6, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_y_spinbutton, _("y rotation"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->rot_x_spinbutton), TRUE);

   pi->rot_z_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->rot_z_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->rot_z_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->rot_z_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_z_spinbutton, 7, 8, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_z_spinbutton, _("z rotation"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->rot_x_spinbutton), TRUE);

   pi->rot_phi_spinbutton_adj = gtk_adjustment_new(0, 0, 359, 1, 12, 0);
   pi->rot_phi_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->rot_phi_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->rot_phi_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_phi_spinbutton, 7, 8, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_phi_spinbutton, _("phi rotation"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->rot_phi_spinbutton), TRUE);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(pi->rot_phi_spinbutton), TRUE);

   pi_rot_phi_label = gtk_label_new(_("phi"));
   gtk_widget_show(pi_rot_phi_label);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi_rot_phi_label, 5, 6, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_label_set_justify(GTK_LABEL(pi_rot_phi_label), GTK_JUSTIFY_RIGHT);
   gtk_misc_set_alignment(GTK_MISC(pi_rot_phi_label), 0.93, 0.5);

   pi->rot_lock_phi_button = gtk_toggle_button_new();
   gtk_widget_show(pi->rot_lock_phi_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_lock_phi_button, 6, 7, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_lock_phi_button, _("lock the phi rotation"),
                        NULL);

   pi_rot_lock_phi_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_rot_lock_phi_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->rot_lock_phi_button), pi_rot_lock_phi_pixmap);

   /* translation */
   pi_trans_button = gtk_button_new();
   gtk_widget_show(pi_trans_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi_trans_button, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_trans_button, _("click to reset translations"),
                        NULL);

   pi_trans_pixmap = create_pixmap(pane_info_dialog, TRANSLATION_PIXMAP);
   gtk_widget_show(pi_trans_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_trans_button), pi_trans_pixmap);

   pi->trans_x_spinbutton_adj = gtk_adjustment_new(0, -400, 400, 1, 10, 0);
   pi->trans_x_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->trans_x_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->trans_x_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_x_spinbutton, 3, 4, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_x_spinbutton, _("x translation"), NULL);

   pi->trans_y_spinbutton_adj = gtk_adjustment_new(0, -400, 400, 1, 10, 0);
   pi->trans_y_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->trans_y_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->trans_y_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_y_spinbutton, 5, 6, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_y_spinbutton, _("y translation"), NULL);

   pi->trans_z_spinbutton_adj = gtk_adjustment_new(0, -400, 400, 1, 10, 0);
   pi->trans_z_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->trans_z_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->trans_z_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_z_spinbutton, 7, 8, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_z_spinbutton, _("z translation"), NULL);

   /* tilt */
   pi_tilt_button = gtk_button_new();
   gtk_widget_show(pi_tilt_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi_tilt_button, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_tilt_button, _("click to reset tilts"), NULL);

   pi_tilt_pixmap = create_pixmap(pane_info_dialog, TILT_PIXMAP);
   gtk_widget_show(pi_tilt_pixmap);
   gtk_container_add(GTK_CONTAINER(pi_tilt_button), pi_tilt_pixmap);

   pi->tilt_x_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->tilt_x_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->tilt_x_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->tilt_x_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_x_spinbutton, 3, 4, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_x_spinbutton, _("x tilt"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->tilt_x_spinbutton), TRUE);

   pi->tilt_y_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->tilt_y_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->tilt_y_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->tilt_y_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_y_spinbutton, 5, 6, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_y_spinbutton, _("y tilt"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->tilt_y_spinbutton), TRUE);

   pi->tilt_z_spinbutton_adj = gtk_adjustment_new(0, -1, 1, 0.01, 0.1, 0);
   pi->tilt_z_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->tilt_z_spinbutton_adj), 0.01, 2);
   gtk_widget_show(pi->tilt_z_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_z_spinbutton, 7, 8, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_z_spinbutton, _("z tilt"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->tilt_z_spinbutton), TRUE);

   /* lock buttons and picmaps... */
   pi->rot_lock_x_button = gtk_toggle_button_new();
   gtk_widget_show(pi->rot_lock_x_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_lock_x_button, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_lock_x_button, _("lock the x rotation"), NULL);

   pi_rot_lock_x_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_rot_lock_x_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->rot_lock_x_button), pi_rot_lock_x_pixmap);

   pi->trans_lock_x_button = gtk_toggle_button_new();
   gtk_widget_show(pi->trans_lock_x_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_lock_x_button, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_lock_x_button, _("lock the x translation"),
                        NULL);

   pi_trans_lock_x_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_trans_lock_x_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->trans_lock_x_button), pi_trans_lock_x_pixmap);

   pi->tilt_lock_x_button = gtk_toggle_button_new();
   gtk_widget_show(pi->tilt_lock_x_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_lock_x_button, 2, 3, 3, 4,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_lock_x_button, _("lock the x tilt"), NULL);

   pi_tilt_lock_x_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_tilt_lock_x_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->tilt_lock_x_button), pi_tilt_lock_x_pixmap);

   pi->rot_lock_y_button = gtk_toggle_button_new();
   gtk_widget_show(pi->rot_lock_y_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_lock_y_button, 4, 5, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_lock_y_button, _("lock the y rotation"), NULL);

   pi_rot_lock_y_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_rot_lock_y_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->rot_lock_y_button), pi_rot_lock_y_pixmap);

   pi->trans_lock_y_button = gtk_toggle_button_new();
   gtk_widget_show(pi->trans_lock_y_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_lock_y_button, 4, 5, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_lock_y_button, _("lock the y translation"),
                        NULL);

   pi_trans_lock_y_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_trans_lock_y_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->trans_lock_y_button), pi_trans_lock_y_pixmap);

   pi->tilt_lock_y_button = gtk_toggle_button_new();
   gtk_widget_show(pi->tilt_lock_y_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_lock_y_button, 4, 5, 3, 4,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_lock_y_button, _("lock the y tilt"), NULL);

   pi_tilt_lock_y_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_tilt_lock_y_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->tilt_lock_y_button), pi_tilt_lock_y_pixmap);

   pi->rot_lock_z_button = gtk_toggle_button_new();
   gtk_widget_show(pi->rot_lock_z_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->rot_lock_z_button, 6, 7, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->rot_lock_z_button, _("lock the z rotation"), NULL);

   pi_rot_lock_z_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_rot_lock_z_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->rot_lock_z_button), pi_rot_lock_z_pixmap);

   pi->trans_lock_z_button = gtk_toggle_button_new();
   gtk_widget_show(pi->trans_lock_z_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->trans_lock_z_button, 6, 7, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->trans_lock_z_button, _("lock the z translation"),
                        NULL);

   pi_trans_lock_z_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_trans_lock_z_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->trans_lock_z_button), pi_trans_lock_z_pixmap);

   pi->tilt_lock_z_button = gtk_toggle_button_new();
   gtk_widget_show(pi->tilt_lock_z_button);
   gtk_table_attach(GTK_TABLE(pi_view_det_table), pi->tilt_lock_z_button, 6, 7, 3, 4,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->tilt_lock_z_button, _("lock the z tilt"), NULL);

   pi_tilt_lock_z_pixmap = create_pixmap(pane_info_dialog, LOCKED_PIXMAP);
   gtk_widget_show(pi_tilt_lock_z_pixmap);
   gtk_container_add(GTK_CONTAINER(pi->tilt_lock_z_button), pi_tilt_lock_z_pixmap);

   /* cmap frame */
   pi->cmap_frame = gtk_frame_new(_("Color Map (min/max alpha)"));
   gtk_widget_show(pi->cmap_frame);
   gtk_box_pack_start(GTK_BOX(pi_vbox), pi->cmap_frame, FALSE, TRUE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(pi->cmap_frame), 3);

   pi_cmap_vbox = gtk_vbox_new(FALSE, 3);
   gtk_widget_show(pi_cmap_vbox);
   gtk_container_add(GTK_CONTAINER(pi->cmap_frame), pi_cmap_vbox);
   gtk_container_set_border_width(GTK_CONTAINER(pi_cmap_vbox), 3);

   pi_cmap_table = gtk_table_new(2, 5, FALSE);
   gtk_widget_show(pi_cmap_table);
   gtk_box_pack_start(GTK_BOX(pi_cmap_vbox), pi_cmap_table, TRUE, TRUE, 0);

   pi->cmap_min_spinbutton = gtk_spin_button_new(NULL, 1, 0);
   gtk_widget_show(pi->cmap_min_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_min_spinbutton, 0, 1, 0, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_min_spinbutton,
                        _("Minimum value for Colourmap"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->cmap_min_spinbutton), TRUE);

   pi->cmap_max_spinbutton = gtk_spin_button_new(NULL, 1, 0);
   gtk_widget_show(pi->cmap_max_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_max_spinbutton, 4, 5, 0, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_max_spinbutton,
                        _("Maximum value for Colourmap"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->cmap_max_spinbutton), TRUE);

   pi->cmap_max_hscale = gtk_hscale_new(NULL);
   gtk_widget_show(pi->cmap_max_hscale);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_max_hscale, 1, 4, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_scale_set_draw_value(GTK_SCALE(pi->cmap_max_hscale), FALSE);

   pi->cmap_min_hscale = gtk_hscale_new(NULL);
   gtk_widget_show(pi->cmap_min_hscale);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_min_hscale, 1, 4, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_scale_set_draw_value(GTK_SCALE(pi->cmap_min_hscale), FALSE);

   /* alpha spin and hscale */
   pi->cmap_alpha_spinbutton_adj = gtk_adjustment_new(0.1, 0, 1, 0.05, 0.1, 0);
   pi->cmap_alpha_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->cmap_alpha_spinbutton_adj), 1, 3);
   gtk_widget_show(pi->cmap_alpha_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_alpha_spinbutton, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_alpha_spinbutton, _("alpha cutoff value"),
                        NULL);

   pi->cmap_alpha_hscale = gtk_hscale_new(GTK_ADJUSTMENT(pi->cmap_alpha_spinbutton_adj));
   gtk_widget_show(pi->cmap_alpha_hscale);
   gtk_table_attach(GTK_TABLE(pi_cmap_table), pi->cmap_alpha_hscale, 1, 5, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
   gtk_scale_set_draw_value(GTK_SCALE(pi->cmap_alpha_hscale), FALSE);
   gtk_scale_set_value_pos(GTK_SCALE(pi->cmap_alpha_hscale), GTK_POS_RIGHT);
   gtk_scale_set_digits(GTK_SCALE(pi->cmap_alpha_hscale), 2);

   pi_cmap_type_hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(pi_cmap_type_hbox);
   gtk_box_pack_start(GTK_BOX(pi_cmap_vbox), pi_cmap_type_hbox, FALSE, TRUE, 0);

   pi->cmap_grey_button = gtk_button_new_with_label(_("grey"));
   gtk_widget_show(pi->cmap_grey_button);
   gtk_box_pack_start(GTK_BOX(pi_cmap_type_hbox), pi->cmap_grey_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_grey_button, _("Grey Colourmap(default)"),
                        NULL);

   pi->cmap_hot_button = gtk_button_new_with_label(_("hot"));
   gtk_widget_show(pi->cmap_hot_button);
   gtk_box_pack_start(GTK_BOX(pi_cmap_type_hbox), pi->cmap_hot_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_hot_button, _("HotMetal Colourmap"), NULL);

   pi->cmap_spect_button = gtk_button_new_with_label(_("spect"));
   gtk_widget_show(pi->cmap_spect_button);
   gtk_box_pack_start(GTK_BOX(pi_cmap_type_hbox), pi->cmap_spect_button, FALSE, FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_spect_button, _("Spectral Colourmap"), NULL);

   pi->cmap_bluered_button = gtk_button_new_with_label(_("bluered"));
   gtk_widget_show(pi->cmap_bluered_button);
   gtk_box_pack_start(GTK_BOX(pi_cmap_type_hbox), pi->cmap_bluered_button, FALSE,
                      FALSE, 0);
   gtk_tooltips_set_tip(tooltips, pi->cmap_bluered_button, _("Blue-Red Colourmap"), NULL);

   pi->cmap_combo = gtk_combo_new();
   gtk_widget_show(pi->cmap_combo);
   gtk_box_pack_start(GTK_BOX(pi_cmap_type_hbox), pi->cmap_combo, TRUE, TRUE, 0);
   gtk_combo_set_value_in_list(GTK_COMBO(pi->cmap_combo), TRUE, FALSE);
   gtk_combo_set_case_sensitive(GTK_COMBO(pi->cmap_combo), TRUE);
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, "");
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("Red"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("Green"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("Blue"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("HotRed"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("HotBlue"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("HotGreen"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("Grey"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("HotMetal"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("Spectral"));
   pi_cmap_combo_items = g_list_append(pi_cmap_combo_items, _("BlueRed"));
   gtk_combo_set_popdown_strings(GTK_COMBO(pi->cmap_combo), pi_cmap_combo_items);
   g_list_free(pi_cmap_combo_items);

   pi->cmap_combo_entry = GTK_COMBO(pi->cmap_combo)->entry;
   gtk_widget_show(pi->cmap_combo_entry);
   gtk_editable_set_editable(GTK_EDITABLE(pi->cmap_combo_entry), FALSE);

   /* vector frame */
   pi->vector_frame = gtk_frame_new(_("Vector"));
   gtk_widget_show(pi->vector_frame);
   gtk_box_pack_start(GTK_BOX(pi_vbox), pi->vector_frame, FALSE, TRUE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(pi->vector_frame), 3);

   pi_vector_vbox = gtk_vbox_new(FALSE, 3);
   gtk_widget_show(pi_vector_vbox);
   gtk_container_add(GTK_CONTAINER(pi->vector_frame), pi_vector_vbox);
   gtk_container_set_border_width(GTK_CONTAINER(pi_vector_vbox), 3);

   pi_vector_options_table = gtk_table_new(3, 4, FALSE);
   gtk_widget_show(pi_vector_options_table);
   gtk_box_pack_start(GTK_BOX(pi_vector_vbox), pi_vector_options_table, TRUE, TRUE, 0);
   gtk_table_set_row_spacings(GTK_TABLE(pi_vector_options_table), 3);
   gtk_table_set_col_spacings(GTK_TABLE(pi_vector_options_table), 3);

   pi->vector_alpha_mult_euc_checkbutton =
      gtk_check_button_new_with_label(_("alpha *= euc length"));
   gtk_widget_show(pi->vector_alpha_mult_euc_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table),
                    pi->vector_alpha_mult_euc_checkbutton, 0, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_alpha_mult_euc_checkbutton,
                        _("use the euclidian length for the alpha value"), NULL);

   pi_vector_mult_button = gtk_button_new_with_label(_("vec mult"));
   gtk_widget_show(pi_vector_mult_button);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi_vector_mult_button, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_vector_mult_button,
                        _("click to reset vector multiplier"), NULL);

   pi_vector_mult_spinbutton_adj = gtk_adjustment_new(1, 0.001, 1000, 0.01, 0.1, 0);
   pi->vector_mult_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi_vector_mult_spinbutton_adj), 1, 3);
   gtk_widget_show(pi->vector_mult_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_mult_spinbutton, 1, 2,
                    1, 2, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_mult_spinbutton, _("vector scale factor"),
                        NULL);

   pi_vector_alpha_mult_spinbutton_adj = gtk_adjustment_new(1, 0.001, 1000, 0.01, 0.1, 0);
   pi->vector_alpha_mult_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi_vector_alpha_mult_spinbutton_adj), 1, 3);
   gtk_widget_show(pi->vector_alpha_mult_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_alpha_mult_spinbutton,
                    1, 2, 2, 3, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_alpha_mult_spinbutton,
                        _("vector alpha scale factor"), NULL);

   pi_vector_colour_button = gtk_button_new_with_label(_("vect colour"));
   gtk_widget_show(pi_vector_colour_button);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi_vector_colour_button, 2, 3, 1,
                    2, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_vector_colour_button,
                        _("click to reset vector colour"), NULL);

   pi_point_color_button = gtk_button_new_with_label(_("point colour"));
   gtk_widget_show(pi_point_color_button);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi_point_color_button, 2, 3, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_point_color_button, _("click to reset point colour"),
                        NULL);

   pi->vector_points_checkbutton = gtk_check_button_new_with_label(_("points"));
   gtk_widget_show(pi->vector_points_checkbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_points_checkbutton, 2,
                    3, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_points_checkbutton,
                        _("show points at the origin of vectors"), NULL);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pi->vector_points_checkbutton), TRUE);

   /* gnome colour picker widgets */
   pi->vector_colourpicker = gtk_color_selection_new();
//   gnome_color_picker_set_d(GNOME_COLOR_PICKER(pi->vector_colourpicker),
//                            0.0, 0.0, 0.0, 1.0);
   gtk_widget_show(pi->vector_colourpicker);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_colourpicker, 3, 4, 1,
                    2, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);

   pi->vector_point_colourpicker = gtk_color_selection_new();
//   gtk_color_selection_set_current_color(GTK_COLOR_SELECTION(pi->vector_point_colourpicker),
//                                         0,0,0,0.5);
   gtk_widget_show(pi->vector_point_colourpicker);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_point_colourpicker, 3,
                    4, 2, 3, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);

   /* normal buttons and stuff */
   pi_alpha_mult_button = gtk_button_new_with_label(_("alpha mult"));
   gtk_widget_show(pi_alpha_mult_button);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi_alpha_mult_button, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi_alpha_mult_button,
                        _("click to reset vector alpha multiplier"), NULL);

   pi->vector_rgb_togglebutton = gtk_toggle_button_new_with_label(_("RGB vectors"));
   gtk_widget_show(pi->vector_rgb_togglebutton);
   gtk_table_attach(GTK_TABLE(pi_vector_options_table), pi->vector_rgb_togglebutton, 3, 4,
                    0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_rgb_togglebutton,
                        _("colour code vectors by direction"), NULL);

   pi_vector_range_table = gtk_table_new(2, 4, TRUE);
   gtk_widget_show(pi_vector_range_table);
   gtk_box_pack_start(GTK_BOX(pi_vector_vbox), pi_vector_range_table, FALSE, TRUE, 0);

   pi->vector_max_spinbutton_adj = gtk_adjustment_new(255, 0, 255, 1, 10, 0);
   pi->vector_max_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->vector_max_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->vector_max_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_range_table), pi->vector_max_spinbutton, 3, 4, 0,
                    2, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0),
                    0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_max_spinbutton,
                        _("maximum vector to show(euclidian distance)"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->vector_max_spinbutton), TRUE);

   pi->vector_min_spinbutton_adj = gtk_adjustment_new(0, 0, 255, 1, 10, 0);
   pi->vector_min_spinbutton =
      gtk_spin_button_new(GTK_ADJUSTMENT(pi->vector_min_spinbutton_adj), 1, 2);
   gtk_widget_show(pi->vector_min_spinbutton);
   gtk_table_attach(GTK_TABLE(pi_vector_range_table), pi->vector_min_spinbutton, 0, 1, 0,
                    2, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0),
                    0, 0);
   gtk_tooltips_set_tip(tooltips, pi->vector_min_spinbutton,
                        _("minimum vector to show(euclidian distance)"), NULL);
   gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(pi->vector_min_spinbutton), TRUE);

   pi->vector_min_hscale =
      gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(0, 0, 256, 1, 10, 0)));
   gtk_widget_show(pi->vector_min_hscale);
   gtk_table_attach(GTK_TABLE(pi_vector_range_table), pi->vector_min_hscale, 1, 3, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
   gtk_scale_set_draw_value(GTK_SCALE(pi->vector_min_hscale), FALSE);

   pi->vector_max_hscale =
      gtk_hscale_new(GTK_ADJUSTMENT(gtk_adjustment_new(246, 0, 256, 1, 10, 0)));
   gtk_widget_show(pi->vector_max_hscale);
   gtk_table_attach(GTK_TABLE(pi_vector_range_table), pi->vector_max_hscale, 1, 3, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
   gtk_scale_set_draw_value(GTK_SCALE(pi->vector_max_hscale), FALSE);

   /* merge frame */
   pi->merge_frame = gtk_frame_new(_("Merge"));
   gtk_widget_show(pi->merge_frame);
   gtk_box_pack_start(GTK_BOX(pi_vbox), pi->merge_frame, FALSE, TRUE, 0);
   gtk_container_set_border_width(GTK_CONTAINER(pi->merge_frame), 3);

   pi_merge_table = gtk_table_new(2, 3, FALSE);
   gtk_widget_show(pi_merge_table);
   gtk_container_add(GTK_CONTAINER(pi->merge_frame), pi_merge_table);
   gtk_container_set_border_width(GTK_CONTAINER(pi_merge_table), 3);
   gtk_table_set_row_spacings(GTK_TABLE(pi_merge_table), 2);
   gtk_table_set_col_spacings(GTK_TABLE(pi_merge_table), 2);

   for(c = 0; c < NUM_MERGE_COEFF; c++){

      pi->merge_combo[c] = gtk_combo_new();
      gtk_widget_show(pi->merge_combo[c]);
      gtk_table_attach(GTK_TABLE(pi_merge_table), pi->merge_combo[c], 0, 1, c, c + 1,
                       (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0, 0);
      gtk_combo_set_value_in_list(GTK_COMBO(pi->merge_combo[c]), TRUE, TRUE);
      gtk_combo_set_popdown_strings(GTK_COMBO(pi->merge_combo[c]), ptr->pane_filelist);

      pi->merge_combo_entry[c] = GTK_COMBO(pi->merge_combo[c])->entry;
      gtk_widget_show(pi->merge_combo_entry[c]);

      pi->merge_coeff_adj[c] = gtk_adjustment_new(50, 0, 100.1, 1, 1, 0);
      pi->merge_hscale[c] = gtk_hscale_new(GTK_ADJUSTMENT(pi->merge_coeff_adj[c]));
      gtk_widget_show(pi->merge_hscale[c]);
      gtk_table_attach(GTK_TABLE(pi_merge_table), pi->merge_hscale[c], 1, 2, c, c + 1,
                       (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0),
                       0, 0);
      gtk_scale_set_value_pos(GTK_SCALE(pi->merge_hscale[c]), GTK_POS_RIGHT);
      gtk_scale_set_digits(GTK_SCALE(pi->merge_hscale[c]), 1);

      pi->merge_link_button[c] = gtk_toggle_button_new();
      gtk_widget_show(pi->merge_link_button[c]);
      gtk_table_attach(GTK_TABLE(pi_merge_table), pi->merge_link_button[c], 2, 3, c,
                       c + 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0), 0,
                       0);
      gtk_tooltips_set_tip(tooltips, pi->merge_link_button[0],
                           _("link scales between views"), NULL);

      pi->merge_link_pixmap[c] = create_pixmap(pane_info_dialog, CHAIN_V_PIXMAP);
      gtk_widget_show(pi->merge_link_pixmap[c]);
      gtk_container_add(GTK_CONTAINER(pi->merge_link_button[c]),
                        pi->merge_link_pixmap[c]);

      /* merge signals */
      g_signal_connect(G_OBJECT(pi->merge_combo_entry[c]), "changed",
                       G_CALLBACK(pi_merge_combo_entry_changed), GINT_TO_POINTER(c));
      g_signal_connect(G_OBJECT(pi->merge_coeff_adj[c]), "value-changed",
                       G_CALLBACK(pi_merge_coeff_value_changed), GINT_TO_POINTER(c));
      g_signal_connect(G_OBJECT(pi->merge_link_button[c]), "toggled",
                       G_CALLBACK(pi_merge_link_button_toggled), GINT_TO_POINTER(c));

      }

   /* first add signals that don't need blocking */
   g_signal_connect(G_OBJECT(pi_pane_add_button), "clicked",
                    G_CALLBACK(pi_pane_add_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_pane_clone_button), "clicked",
                    G_CALLBACK(pi_pane_clone_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_pane_close_button), "clicked",
                    G_CALLBACK(pi_pane_close_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_view_add_button), "clicked",
                    G_CALLBACK(pi_view_add_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_view_close_button), "clicked",
                    G_CALLBACK(pi_view_close_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_view_clone_button), "clicked",
                    G_CALLBACK(pi_view_clone_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_scale_button), "clicked",
                    G_CALLBACK(pi_scale_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_trans_button), "clicked",
                    G_CALLBACK(pi_trans_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_rot_button), "clicked",
                    G_CALLBACK(pi_rot_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_tilt_button), "clicked",
                    G_CALLBACK(pi_tilt_button_clicked), ptr);
   
   /* cmap */
   g_signal_connect(G_OBJECT(pi->cmap_alpha_spinbutton), "changed",
                    G_CALLBACK(pi_cmap_alpha_spinbutton_changed), ptr);
   g_signal_connect(G_OBJECT(pi->cmap_grey_button), "clicked",
                    G_CALLBACK(pi_cmap_grey_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->cmap_hot_button), "clicked",
                    G_CALLBACK(pi_cmap_hot_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->cmap_spect_button), "clicked",
                    G_CALLBACK(pi_cmap_spect_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->cmap_bluered_button), "clicked",
                    G_CALLBACK(pi_cmap_bluered_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->cmap_combo_entry), "changed",
                    G_CALLBACK(pi_cmap_combo_entry_changed), ptr);
   
   
   /* connect signals, recording id's as we go so that we can block them later */
   signal_id = g_signal_connect(G_OBJECT(pi->linear_interp_checkbutton), "toggled",
                                G_CALLBACK(pi_linear_interp_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->linear_interp_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->vector_checkbutton), "toggled",
                                G_CALLBACK(pi_vector_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->vector_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->perspective_checkbutton), "toggled",
                                G_CALLBACK(pi_perspective_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->perspective_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->bbox_checkbutton), "toggled",
                                G_CALLBACK(pi_bbox_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->bbox_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->sbox_checkbutton), "toggled",
                                G_CALLBACK(pi_sbox_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->sbox_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->crosshair_checkbutton), "toggled",
                                G_CALLBACK(pi_crosshair_checkbutton_toggled), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->crosshair_checkbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->crosshair_spinbutton), "changed",
                                G_CALLBACK(pi_crosshair_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->crosshair_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->view_type_combo_entry), "changed",
                                G_CALLBACK(pi_view_type_combo_entry_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->view_type_combo_entry);

   /* view table */
   signal_id = g_signal_connect(G_OBJECT(pi->scale_link_button), "clicked",
                                G_CALLBACK(pi_scale_link_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->scale_link_button);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_link_button), "clicked",
                                G_CALLBACK(pi_trans_link_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_link_button);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_link_button), "clicked",
                                G_CALLBACK(pi_rot_link_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_link_button);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_link_button), "clicked",
                                G_CALLBACK(pi_tilt_link_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_link_button);

   signal_id = g_signal_connect(G_OBJECT(pi->scale_spinbutton), "changed",
                                G_CALLBACK(pi_scale_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->scale_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_x_spinbutton), "changed",
                                G_CALLBACK(pi_trans_x_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_x_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_y_spinbutton), "changed",
                                G_CALLBACK(pi_trans_y_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_y_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_z_spinbutton), "changed",
                                G_CALLBACK(pi_trans_z_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_z_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_x_spinbutton), "changed",
                                G_CALLBACK(pi_rot_x_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_x_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_y_spinbutton), "changed",
                                G_CALLBACK(pi_rot_y_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_y_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_z_spinbutton), "changed",
                                G_CALLBACK(pi_rot_z_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_z_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_phi_spinbutton), "changed",
                                G_CALLBACK(pi_rot_phi_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_phi_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_x_spinbutton), "changed",
                                G_CALLBACK(pi_tilt_x_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_x_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_y_spinbutton), "changed",
                                G_CALLBACK(pi_tilt_y_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_y_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_z_spinbutton), "changed",
                                G_CALLBACK(pi_tilt_z_spinbutton_changed), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_z_spinbutton);

   signal_id = g_signal_connect(G_OBJECT(pi->scale_lock_button), "clicked",
                                G_CALLBACK(pi_scale_lock_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->scale_lock_button);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_lock_x_button), "clicked",
                                G_CALLBACK(pi_trans_lock_x_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_lock_x_button);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_lock_y_button), "clicked",
                                G_CALLBACK(pi_trans_lock_y_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_lock_y_button);

   signal_id = g_signal_connect(G_OBJECT(pi->trans_lock_z_button), "clicked",
                                G_CALLBACK(pi_trans_lock_z_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->trans_lock_z_button);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_lock_x_button), "clicked",
                                G_CALLBACK(pi_rot_lock_x_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_lock_x_button);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_lock_y_button), "clicked",
                                G_CALLBACK(pi_rot_lock_y_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_lock_y_button);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_lock_z_button), "clicked",
                                G_CALLBACK(pi_rot_lock_z_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_lock_z_button);

   signal_id = g_signal_connect(G_OBJECT(pi->rot_lock_phi_button), "clicked",
                                G_CALLBACK(pi_rot_lock_phi_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->rot_lock_phi_button);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_lock_x_button), "clicked",
                                G_CALLBACK(pi_tilt_lock_x_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_lock_x_button);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_lock_y_button), "clicked",
                                G_CALLBACK(pi_tilt_lock_y_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_lock_y_button);

   signal_id = g_signal_connect(G_OBJECT(pi->tilt_lock_z_button), "clicked",
                                G_CALLBACK(pi_tilt_lock_z_button_clicked), ptr);
   g_array_append_val(pi->signal_ids, signal_id);
   g_ptr_array_add(pi->obj_ptrs, (gpointer)pi->tilt_lock_z_button);

   /* vector */
   g_signal_connect(G_OBJECT(pi->vector_colourpicker), "color_changed",
                    G_CALLBACK(pi_vector_colourpicker_color_changed), ptr);
   g_signal_connect(G_OBJECT(pi->vector_point_colourpicker), "color_changed",
                    G_CALLBACK(pi_vector_point_colourpicker_color_changed), ptr);

   g_signal_connect(G_OBJECT(pi->vector_alpha_mult_euc_checkbutton), "toggled",
                    G_CALLBACK(pi_vector_alpha_mult_euc_checkbutton_toggled), ptr);
   g_signal_connect(G_OBJECT(pi_vector_mult_button), "clicked",
                    G_CALLBACK(pi_vector_mult_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->vector_mult_spinbutton), "changed",
                    G_CALLBACK(pi_vector_mult_spinbutton_changed), ptr);
   g_signal_connect(G_OBJECT(pi->vector_alpha_mult_spinbutton), "changed",
                    G_CALLBACK(pi_vector_alpha_mult_spinbutton_changed), ptr);
   g_signal_connect(G_OBJECT(pi_vector_colour_button), "clicked",
                    G_CALLBACK(pi_vector_colour_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi_point_color_button), "clicked",
                    G_CALLBACK(pi_point_color_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->vector_points_checkbutton), "toggled",
                    G_CALLBACK(pi_vector_points_checkbutton_toggled), ptr);
   g_signal_connect(G_OBJECT(pi_alpha_mult_button), "clicked",
                    G_CALLBACK(pi_alpha_mult_button_clicked), ptr);
   g_signal_connect(G_OBJECT(pi->vector_rgb_togglebutton), "toggled",
                    G_CALLBACK(pi_vector_rgb_togglebutton_toggled), ptr);
   g_signal_connect(G_OBJECT(pi->vector_max_spinbutton), "changed",
                    G_CALLBACK(pi_vector_max_spinbutton_changed), ptr);
   g_signal_connect(G_OBJECT(pi->vector_min_spinbutton), "changed",
                    G_CALLBACK(pi_vector_min_spinbutton_changed), ptr);

   g_signal_connect(G_OBJECT(pane_info_dialog), "delete_event",
                    G_CALLBACK(pane_info_dialog_delete_event), NULL);

   g_object_set_data(G_OBJECT(pane_info_dialog), "tooltips", tooltips);

   return pane_info_dialog;
   }
